<!--#include file="adovbs.inc"-->
<%
Response.Buffer = True

Const DebugMode = True

'Const SYS_TABLE_PREFIX = "tbl_sys_"
Const SYS_TABLE_PREFIX = "tbl_"

Const PM_ROOT = "/softme"
Const PM_NEWSLINE = 5
Const PM_MAX_LIST_ROW = 40
'Const PM_TABLE_PREFIX = "tbl_pm_"
Const PM_TABLE_PREFIX = "tbl_"

Dim		PM_NavPage
Dim		PM_DBProvider

PM_DBProvider = "Access"
'PM_DBProvider = "MSSQL7"

'''' Database connection
Function PM_GetDatabaseConn()
	Dim oRet
	Dim strConn
	Select Case PM_DBProvider
	Case "Access"
		Dim strDBPath
		strDBPath = Server.MapPath(PM_ROOT & "/db/webpm10a.mdb")
		strConn = "DRIVER={Microsoft Access Driver (*.mdb)};DBQ="& strDBPath
	Case "MSSQL7"
		strConn = "Provider=SQLOLEDB.1;Data Source=boonx2;User ID=sa;Initial Catalog=webpm;"
	End Select
	Set oRet = Server.CreateObject	("ADODB.Connection")
	oRet.Open strConn
	Set PM_GetDatabaseConn = oRet
End Function

Function PM_CheckACL(pRole)
	Select Case LCase(pRole)
	Case "admin"
		if Session("PM_Admin") = "yes" then
			PM_CheckACL = True
		Else
			PM_CheckACL = False
			Response.Redirect( PM_ROOT & "/reg/login.asp")
		End if 
	Case "user"
		if Session("PM_UserID") <> "" then
			PM_CheckACL = True
		Else
			PM_CheckACL = False
			Response.Redirect( PM_ROOT & "/reg/login.asp")
		End if 
	End Select
End Function

'''Ƚ״̬
Function PM_CheckState(pState, pCurState)
	If pState = pCurState Then 
		PM_CheckState = "checked"
	Else
		PM_CheckState = ""
	End If
End Function


''''Some ads if you'd like
Function PM_GetAd(pName)
	Dim sp

	sp = " | "
	
	Select Case lCase(pName)
		Case "title"
			PM_GetAd = "Project Management On Web" & _
						"<br><center>߷͹ĿϢ</center>"
		Case "home"
			PM_GetAd = "<a href=""" & PM_ROOT & "/index.asp"">ҳ</a>"
		Case "sign"
			PM_GetAd = "<font color=""red"">һֱŬ</font>"
		Case "comment"
			PM_GetAd = "<a href=""mailto:brokendoor@sina.com"">ⷴ!</a>"
		Case "copyright"
			PM_GetAd = "Copyright &copy; 2001, Softme Studio."
		Case "source"
			PM_GetAd = "These Project are maintained with WebPM - a totally free product available " & _
				" for download <a href=""" & PM_ROOT & "/download/webpm.zip"">here</a>."
		Case "author"
			PM_GetAd = "Last Modified By brokendoor, <a href=""http://brokendoor.myetang.com"">Softme Studio</a>"

	End Select	
End Function

Function PM_GetPrjNav(pID)
	Dim sp, strRtn

	sp = " | "
	strRtn =  "<a href=""" & PM_ROOT & "/usr/prjinfo.asp" & "?fID=" & pID & """>Ϣ</a>" & sp _
			& "<a href=""" & PM_ROOT & "/usr/prjevent.asp""" & "?fID=" & pID & """>¼</a> " & sp _
			& "<a href=""" & PM_ROOT & "/usr/prjtask.asp""" & "?fID=" & pID & """></a> " & sp _
			& "<a href=""" & PM_ROOT & "/usr/prjmember.asp""" & "?fID=" & pID & """>Ա</a> " & sp _
			& "<a href=""" & PM_ROOT & "/usr/prjdoc.asp""" & "?fID=" & pID & """>ĵ</a> " & sp _
			& "<a href=""" & PM_ROOT & "/usr/prjfile.asp""" & "?fID=" & pID & """>ļ</a> " & sp _
			& "<a href=""" & PM_ROOT & "/usr/prjbbs.asp""" & "?fID=" & pID & """>̳</a> "
	PM_GetPrjNav = strRtn
End Function 

Function PM_GetNavIndex()
	Dim sp, strRtn

	sp = "<br><br>"
	Select Case LCase(PM_NavPage)
	Case "root"
		strRtn =  "<a href=""" & PM_ROOT & "/reg/login.asp"">¼ϵͳ</a>" & sp _
				& "<a href=""" & PM_ROOT & "/reg/register.asp"">עû</a> "
	Case Else
		If Trim(Session("PM_UserID")) = "" Then 
			strRtn = "<a href=""" & PM_ROOT & "/index.asp"">ҳ</a>"
		Else
			If Session("PM_Admin") = "yes" Then 
				strRtn = "<a href=""" & PM_ROOT & "/adm/admin.asp"">Ŀ</a>" & sp _
					& "<a href=""" & PM_ROOT & "/adm/admgroup.asp""></a> " & sp _
					& "<a href=""" & PM_ROOT & "/adm/admuser.asp"">û</a>" & sp _
					& "<a href=""" & PM_ROOT & "/reg/logout.asp"">˳</a> "
			Else
				strRtn = "<a href=""" & PM_ROOT & "/usr/home.asp"">Իҳ</a> " & sp _
					& "<a href=""" & PM_ROOT & "/usr/newprj.asp"">Ŀ</a> " & sp _
					& "<a href=""" & PM_ROOT & "/usr/c&d.asp"">ճ</a> " & sp _
					& "<a href=""" & PM_ROOT & "/usr/info.asp"">ʻ</a> " & sp _
					& "<a href=""" & PM_ROOT & "/reg/logout.asp"">˳</a>"
			End if
		End If		
	End Select

	PM_GetNavIndex = strRtn
End Function 

''''System UniKey 
Function PM_GetUniKey()
	'On Error Resume Next

	Dim oConn, strSQL, oRSKey, lRtn

	Set oConn = PM_GetDatabaseConn()
	
	strSQL = "SELECT flongvalue as fValue FROM " & SYS_TABLE_PREFIX & "parm " & _
		" WHERE ( fparmname = 'SysUniKey' ) AND  " & _
		"       ( fparmversion = '1.0' ) AND  " & _
		"	( factivestate = 'A' )   "

	'Open the recordset
	Set oRSKey = oConn.Execute(strSQL)
	
	If oRSKey.EOF And oRSKey.BOF Then 
		' Error in system database
		strSQL = "INSERT INTO " & SYS_TABLE_PREFIX & "parm (fid, fparmname, fparmversion, flongvalue, factivestate)" & _
		" VALUES ( 0, 'SysUniKey','1.0', 2, 'A')  "
		oConn.Execute strSQL
		PM_GetUniKey = 1
		Exit Function
	End If

	' Get the key value
	lRtn = CLng(oRSKey("fValue"))

	' Save back to database
	strSQL = "Update " & SYS_TABLE_PREFIX & "parm SET flongvalue="	& CStr(lRtn + 1)

	oConn.Execute strSQL

	If Err <> 0 Then 
		PM_GetUniKey = -1
	Else
		PM_GetUniKey = lRtn
	End If
End Function

''''System Parms
Function PM_GetParm(pName, pType, pVersion, pDefault)
	'On Error Resume Next

	Dim oConn, strSQL, oRS
	
	if Trim(pType) = "" then 
		pType = "string"
	end if

	if Trim(pVersion) = "" then 
		pVersion = "1.0"
	end if

	Set oConn = PM_GetDatabaseConn()
	
	strSQL = "SELECT fstringvalue as fStringValue, flongvalue as fLongValue FROM " & SYS_TABLE_PREFIX & "parm " & _
		" WHERE ( fparmname = '" & pName & "' ) AND  " & _
		"       ( fparmversion = '" & pVersion & "' ) AND  " & _
		"	( factivestate = 'A' )   "

	'Open the recordset
	Set oRS = oConn.Execute(strSQL)
	
	If oRS.EOF And oRS.BOF Then 
		' Error in system database
		PM_GetParm = pDefault
		Exit Function
	End If

	' Get the key value
	If lcase(pType) = "string" then 
		PM_GetParm = oRS("fStringValue")
	Else
		PM_GetParm = CLng(oRS("fLongValue"))
	End if

End Function

Function PM_SetParm(pName, pType, pVersion, pValue)
	'On Error Resume Next

	Dim oConn, strSQL, oRS
	
	if Trim(pType) = "" then 
		pType = "string"
	end if

	if Trim(pVersion) = "" then 
		pVersion = "1.0"
	end if

	Set oConn = PM_GetDatabaseConn()
	
	If pType = "string" then
		strSQL = "Update " & SYS_TABLE_PREFIX & "parm set fstringvalue = '" & pValue & _
		"' WHERE ( fparmname = '" & pName & "' ) AND  " & _
		"       ( fparmversion = '" & pVersion & "' ) AND  " & _
		"	( factivestate = 'A' )   "
	Else
		strSQL = "Update " & SYS_TABLE_PREFIX & "parm set flongvalue = " & pValue & _
		" WHERE ( fparmname = '" & pName & "' ) AND  " & _
		"       ( fparmversion = '" & pVersion & "' ) AND  " & _
		"	( factivestate = 'A' )   "
	End if

	oConn.Execute(strSQL)
	
	If Err <> 0 Then 
		PM_SetParm = -1
	Else
		PM_SetParm = pValue
	End If

End Function
%>